<?php

  if (isset($_POST['show_add_hub'])) {
    $city_id = $_POST['city_id'];
    show_new_hub_form($city_id);
  }
  else if (isset($_POST['add_hub'])) {
    $id = add_hub($displayname);
    if ($id !== false) {
      echo "<p>Added hub.</p>\n";
      $parameters = array($displayname, $id);
    }
  }
  else if (isset($_POST['update_hub'])) {
    list($name, $id, $args) = parse_parameters($parameters);
    $q = new HubQuery;
    $hub = $q->findOneById($id);
    if ($hub) {
      $area = get_hub_area($hub);
      if ($area) $area_id = $area->getId();
      if (update_hub($hub, $area_id) !== false) {
        echo "<p>Updated hub.</p>\n";
        $parameters = array($hub->getDisplayname(), $hub->getId());
      }
    }
    else {
      echo "<p>No such hub!</p>\n";
    }
  }
  else if ($_POST['area_id']) {
    $q = new AreaQuery;
    $area = $q->findOneById($_POST['area_id']);
    header(sprintf("Location: http%s://%s/%s/in/area/%s/%d", ($_SERVER['HTTPS']) ? "s" : "", $_SERVER['HTTP_HOST'], $module, urlencode($area->getName()), $_POST['area_id']));
    exit;
  }
  else if ($_POST['city_id']) {
    $q = new CityQuery;
    $city = $q->findOneById($_POST['city_id']);
    header(sprintf("Location: http%s://%s/%s/in/city/%s/%d", ($_SERVER['HTTPS']) ? "s" : "", $_SERVER['HTTP_HOST'], $module, urlencode($city->getName()), $_POST['city_id']));
    exit;
  }

  function show_hub_summary(&$hub, $editing = false) {
    if ($editing) echo "<p>Hub: <span class=\"strong\">" . htmlspecialchars($hub->getName()) . "</span>";
    else echo "<br>\nHub " . $hub->getStrongLink();
    $role = $hub->getRole();
    $role_string = get_hub_role_string($hub);
    if ($role_string) echo " $role_string";
    if ($role & $GLOBALS['ROLE_COLLECTION']) printf(" <a class=\"small\" href=\"/donation/to/hub/%s/%d\">Donations</a>", urlencode($hub->getName()), $hub->getId());
    if ($role & $GLOBALS['ROLE_DISTRIBUTION']) printf(" <a class=\"small\" href=\"/order/to/hub/%s/%d\">Orders</a>", urlencode($hub->getName()), $hub->getId());
    if (check_admin(1)) {
      echo " " . $hub->getDeleteLink();
    }
    $area = get_hub_area($hub);
    if ($area) echo " in " . $area->getLink();
    $city = get_hub_city($hub);
    if ($city) echo ", " . $city->getLink(get_city_displayname($city));
  }

  function show_hubs($offset, $per_page, $address_ids) {
    $q = new HubQuery;
    $hubs = $q->filterByAddressId($address_ids)->find();
    if (count($hubs)) {
      foreach ($hubs as $hub) show_hub_summary($hub);
    }
    else echo " none";
  }

  function show_city_hubs($offset, $per_page, $city_name, $city_id = null) {
    if (isset($city_id)) $city = get_city_by_id($city_id);
    else if ($city_name) $city = get_city_by_name($city_name);
    if ($city) {
      $q = new AreaQuery;
      $areas = $q->filterByCityId($city->getId())->find();
      $area_ids = array();
      foreach ($areas as $area) $area_ids[] = $area->getId();

      $q = new AddressQuery;
      $addresses = $q->filterByAreaId($area_ids)->find();
      $address_ids = array();
      foreach ($addresses as $address) $address_ids[] = $address->getId();

      echo "<p>Hubs in city " . $city->getLink(get_city_displayname($city)) . ":";
      return show_hubs($offset, $per_page, $address_ids);
    }
    else echo "<p>No such city!</p>\n";
  }

  function show_area_hubs($offset, $per_page, $area_name, $area_id = null) {
    if (isset($area_id)) $area = get_area_by_id($area_id);
    else if ($area_name) $area = get_area_by_name($area_name);
    if ($area) {
      $q = new AddressQuery;
      $addresses = $q->filterByAreaId($area->getId())->find();
      $address_ids = array();
      foreach ($addresses as $address) $address_ids[] = $address->getId();

      echo "<p>Hubs in area " . $area->getLink() . ":";
      return show_hubs($offset, $per_page, $address_ids);
    }
    else echo "<p>No such area!</p>\n";
  }

  function show_hub_areas_form($city_id = null) {
    $areas = get_city_areas($city_id);
    if (! count($areas)) {
      echo "<p>No <a href=\"/area\">areas</a>!</p>\n";
      return;
    }

    echo "<form method=\"POST\" action=\"" . $_SERVER['REQUEST_URI'] . "\">\n";
    echo "<p>Show hubs in area\n";
    echo "<select name=\"area_id\">\n";
    foreach ($areas as $area) {
      option("area_id", $area->getId(), get_area_displayname($area));
    }
    echo "</select>\n";
    echo "<input type=\"submit\" value=\"Show\">\n";
    echo "</form>\n";
  }

  function show_hub_cities_form($city_id = null) {
    $q = new CityQuery;
    $cities = $q->orderByName()->find();

    if (! count($cities)) {
      echo "<p>No <a href=\"/city\">cities</a>!</p>\n";
      return;
    }

    echo "<form method=\"POST\" action=\"" . $_SERVER['REQUEST_URI'] . "\">\n";
    echo "<p>Show hubs in city\n";
    echo "<select name=\"city_id\">\n";
    foreach ($cities as $city) {
      option("city_id", $city->getId(), get_city_displayname($city), $city_id);
    }
    echo "</select>\n";
    echo "<input type=\"submit\" value=\"Show\">\n";
    echo "</form>\n";
  }

  function show_hub_forms($city_id) {
    show_hub_areas_form($city_id);
    show_hub_cities_form($city_id);
  }

  function show_hub_role_form($role) {
    return show_role_form($role, $GLOBALS['hub_roles']);
  }

  function show_hub_form($hub = null, $area_id = null) {
    if (! $hub) $hub = new Hub;

    /* Role. */
    echo "<tr>\n";
    echo "  <td>Role</td>\n";
    echo "  <td>"; show_hub_role_form($hub->getRole()); echo "</td>\n";
    echo "</tr>\n";

    /* Display name. */
    echo "<tr>\n";
    echo "  <td>Hub name</td>\n";
    echo "  <td>"; input("displayname", $hub->getDisplayname()); echo "</td>\n";
    echo "</tr>\n";

    /* Address. */
    $address = get_hub_address($hub);
    if (! $address) $address = new Address;
    echo "<tr>\n";
    echo "  <td>Address</td>\n";
    echo "  <td>"; textarea("address", $address->getLine()); echo "</td>\n";
    echo "</tr>\n";

    /* Postcode. */
    echo "<tr>\n";
    echo "  <td>Postcode</td>\n";
    echo "  <td>"; input("postcode", $address->getPostcode()); echo "</td>\n";
    echo "</tr>\n";

    /* Telephone. */
    echo "<tr>\n";
    echo "  <td>Telephone</td>\n";
    echo "  <td>"; input("telephone1", $hub->getTelephone1()); echo "</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "  <td>Alternative telephone</td>\n";
    echo "  <td>"; input("telephone2", $hub->getTelephone2()); echo "</td>\n";
    echo "</tr>\n";

    /* Email. */
    echo "<tr>\n";
    echo "  <td>Email</td>\n";
    echo "  <td>"; input("email", $hub->getEmail()); echo "</td>\n";
    echo "</tr>\n";

    /* Area. */
    $areas = get_city_areas();
    if (! isset($area_id)) $area_id = get_hub_area($hub);
    echo "<tr>\n";
    echo "  <td>Area</td>\n";
    echo "  <td><select name=\"area_id\">\n";
    foreach ($areas as $area) {
      option("area_id", $area->getId(), get_area_displayname($area), $area_id);
    }
    echo "  </select></td>\n";
    echo "</tr>\n";
  }

  function show_new_hub_form($city_id = null) {
    if (! check_admin(1)) return;

    $areas = get_city_areas($city_id);
    if (! count($areas)) {
      echo "<p>No <a href=\"/area\">areas</a>!</p>\n";
      return;
    }

    echo "<form method=\"POST\" action=\"" . $_SERVER['REQUEST_URI'] . "\">\n";
    echo "<p>Add a new hub:</p>\n";

    echo "<table>\n";
    show_hub_form($hub);

    echo "<tr>\n";
    echo "  <td colspan=2>"; submit("add_hub", "Add"); echo "</td></tr>\n";
    echo "</tr>\n";
    echo "</table>\n";
    echo "</form>\n";
  }

  function show_add_new_hub_form() {
    if (! check_admin(1)) return;

    $q = new CityQuery;
    $cities = $q->find();
    if (! count($cities)) {
      echo "<p>No <a href=\"/city\">cities</a>!</p>\n";
      return;
    }

    echo "<form method=\"POST\" action=\"" . $_SERVER['REQUEST_URI'] . "\">\n";
    echo "<p>Add a new hub in <select name=\"city_id\">\n";
    foreach ($cities as $city) {
      option("city_id", $city->getId(), get_city_displayname($city));
    }
    echo "</select>";
    submit("show_add_hub", "Proceed");
    echo "</p>\n";
    echo "</form>\n";
  }

  function update_hub(&$hub, $area_id, $new = false) {
    global $hub_roles;

    $role = 0;
    for ($i = 0; $i < count($hub_roles); $i++) {
      if ($_POST['role_' . $i] == "on") $role |= (1 << $i);
    }

    $displayname = $_POST['displayname'];

    if (! $displayname) {
      echo "<p>Must have a name!</p>\n";
      return false;
    }

    /* Get address. */
    $line = $_POST['address'];
    $postcode = $_POST['postcode'];
    $q = new AddressQuery;
    /* XXX: Finding by area properly? */
    $address = $q->filterByAreaId($area_id)->filterByLine($line)->filterByPostcode($postcode)->findOneOrCreate();
    if ($address->isNew()) {
      /* Changing address. */
      //if (! $new)
      /*
        XXX: Check for other hubs at the old address.
        Make this a new address if there are others, but
        provide a link to update other hubs.
      */
      try {
        $address->save();
      }
      catch (Exception $e) {
        echo "<p>Error adding $line.</p>\n";
        return false;
      }
    }

    $telephone1 = $_POST['telephone1'];
    $telephone2 = $_POST['telephone2'];
    $email = $_POST['email'];

    $hub->setRole($role);
    $hub->setDisplayname($displayname);
    $hub->setTelephone1($telephone1);
    $hub->setTelephone2($telephone2);
    $hub->setEmail($email);
    $hub->setAddressId($address->getId());

    try {
      $hub->save();
    }
    catch (Exception $e) {
      if ($new) echo "<p>Error adding $displayname.</p>\n";
      else echo "<p>Error updating $displayname.</p>\n";
      return false;
    }

    return true;
  }

  function add_hub(&$name) {
    if (! check_admin(1, "add a hub")) return;

    $area_id = $_POST['area_id'];
    if (! is_numeric($area_id)) {
      echo "<p>Invalid area!</p>\n";
      return false;
    }

    $area = get_area_by_id($area_id);
    if (! $area) {
      echo "<p>No such area!</p>\n";
      return false;
    }

    $hub = new Hub;
    if (! update_hub($hub, $area_id, true)) return false;
    return $hub->getId();
  }

  function delete_hub($name, $id = null, &$city_id = null) {
    if (! check_admin(1, "delete a hub")) return;

    if (isset($id)) $hub = get_hub_by_id($id);
    else $hub = get_hub_by_name($name);
    if (! $hub) return false;

    ///* Remember city ID for dropdown. */
    //$city_id = $area->getCityId();

    try {
      $hub->delete();
      echo "<p>Deleted hub.</p>\n";
    }
    catch (Exception $e) {
      echo "<p>Error deleting $name!</p>\n";
      return false;
    }

    return true;
  }

  function show_hub($name, &$id = null) {
    if (isset($id)) $hub = get_hub_by_id($id);
    else $hub = get_hub_by_name($name);
    if (! $hub) return;

    echo "<form method=\"POST\" action=\"" . $_SERVER['REQUEST_URI'] . "\">\n";
    show_hub_summary($hub, true);
    echo ": ";
    echo "\n</p>";

    echo "<table>\n";
    show_hub_form($hub);

    if (check_admin(1)) {
      echo "<tr>\n";
      echo "  <td colspan=2>";
      submit("update_hub", "Update");
      echo "</td>\n";
      echo "</tr>\n";
    }

    echo "</table>\n";
    echo "</form>\n";
  }

  /* /hub/in/area/Cambridge/1 */
  if (count($parameters)) {
    if ($parameters[0] == "in") {
      switch ($parameters[1]) {
        case "area":
          $area_id = $parameters[3];
          $_POST['area_id'] = $area_id;
          $q = new AreaQuery;
          $area = $q->findOneById($area_id);
          $city = get_area_city($area);
          if ($city) $city_id = $city->getId();
          show_area_hubs(0, 10, $parameters[2], $area_id);
        break;

        case "city":
          $city_id = $parameters[3];
          $_POST['city_id'] = $city_id;
          $q = new CityQuery;
          $city = $q->findOneById($city_id);
          show_city_hubs(0, 10, $parameters[2], $city_id);
        break;
      }

      show_new_hub_form($city_id);
    }
  }
  list($name, $id, $args) = parse_parameters($parameters);
  //echo "<p>$name($id) " . print_r($args, true) . "</p>\n";
  if (count($args)) {
    switch ($args[0]) {
      case "delete":
        delete_hub($name, $id);
      break;
    }
  }
  else if (isset($name)) show_hub($name, $id);
  else {
    /* XXX: Shown after adding. */
    show_hub_forms($city_id);
    show_add_new_hub_form($city_id);
  }

  if (count($parameters)) {
    show_hub_forms($city_id);
  }

?>
